﻿
#ProgName = "Автопилот 1.0 USB"

Enumeration CustomValue #PB_Event_FirstCustomValue
  #Event_Log
  #Event_SensorData
EndEnumeration

Enumeration FormFont
  #Font_Graph
EndEnumeration

Enumeration Menu 10 ; Идентификаторы меню
  #MenuPopup_Grph
  #MenuPopup_Log
  #MenuPopup_Sensor
EndEnumeration

Enumeration FormMenu ; Пункты меню
  #mItem_Graph_Setting
  #mItem_Graph_AutoScroll
  #mItem_Log_Setting
  #mItem_Log_AutoScroll
  
  #mItem_Sensor_None
  #mItem_Sensor_d1
  #mItem_Sensor_d2
  #mItem_Sensor_d3
  #mItem_Sensor_d4
  #mItem_Sensor_d5
  #mItem_Sensor_d6
EndEnumeration

Enumeration Timer
  #Timer_Sensor ; Таймер для опроса датчиков.
  #Timer_PWM    ; Таймер для формирования ШИМ на LPT порту.
  #Timer_Graph  ; Таймер для отрисовки графика.
EndEnumeration

Enumeration ; Цвета графика.
  #GraphColor_Back    ; Фоновый цвет.
  #GraphColor_Grid    ; Цвет линий сетки.
  #GraphColor_Text    ; Текст.
  #GraphColor_Sensor1 ; Датчик 1 (ав. ТСА).
  #GraphColor_Sensor2 ; Датчик 2 (ав. Конденсатор).
  #GraphColor_Sensor3 ; Датчик 3 (д. Колонна).
  #GraphColor_Sensor4 ; Датчик 4 (д. Куб).
  #GraphColor_Sensor5 ; Датчик 5 (д. Брага).
  #GraphColor_Sensor6 ; Датчик 6
EndEnumeration

Enumeration ; Назначение выводов LPT порта.
  #LPT_Pin_Pulse    ; Пульсирующий сигнал.
  #LPT_Pin_Col1     ; Колонка 1 - Ректификация.
  #LPT_Pin_Valve1   ; Клапан 1 - 'Г. фракция'.
  #LPT_Pin_Valve2   ; Клапан 2 - 'Спирт'.
  #LPT_Pin_Valve3   ; Клапан 3 - 'Т. фракция'.
  #LPT_Pin_Col2     ; Колонка 2 - Дистилляция.
  #LPT_Pin_Col3_Max ; Колонка 3 - Брага, верхний порог.
  #LPT_Pin_Col3_Min ; Колонка 3 - Брага, нижний порог.
  #LPT_Pin_d6       ; Датчик 6.
  #LPT_Pin_Err      ; Сигнал об превышении порога аварийных датчиков или ошибки в одном из датчиков.
EndEnumeration

Enumeration ; Назначение датчиков.
  #Sensor_Use_None ; Не используется.
  #Sensor_Use_d1   ; Датчик 1 - (ав. ТСА)
  #Sensor_Use_d2   ; Датчик 2 - (ав. Конденсатор)
  #Sensor_Use_d3   ; Датчик 3 - (д. Колонна)
  #Sensor_Use_d4   ; Датчик 4 - (д. Куб)
  #Sensor_Use_d5   ; Датчик 5 - (д. Брага)
  #Sensor_Use_d6   ; Датчик 6.
EndEnumeration

#SensorsAll_Flag_Start = 1 ; Если 0, то это первое обращение к датчикам. Температуру можно считать лишь через секунду.


#SensorsFlag_Err         = 1  ; Признак ошибки чтения данных из датчика.
#SensorsFlag_MoreErr     = 2  ; Флаг устанавливается когда происходят несколько ошибок следующих друг за другом.
#SensorsFlag_Update      = 4  ; Сведения о температуре были обновлены.
#SensorsFlag_ConvertT    = 8  ; Датчику была отправлена команда измерения температуры.
#SensorsFlag_NotFound    = 16 ; Датчик не найден.
#SensorsFlag_TermoSensor = 32 ; Это датчик температуры, совместимый с DS18B20.

#Sensor_MaxNoInfo   = 4  ; Максимум допустмых циклов, отсутсвия данных о температуре из потока опроса датчиков.
#Sensor_MaxCountErr = 8  ; Допусимое число ошибок чтения данных датчика, следующих друг за другом.
#Sensor_MaxNoUpdate = 60 ; Максимум циклов чтения температуры без получения достоверных данных.
#Sensor_Max85Err    = 60 ; Допустимое число результатов 85.0 °C, следующих друг за другом.
  
Enumeration ; Типы сообщений лога.
  #Log_TM_Info    ; Информация.
  #Log_TM_Warning ; Предупреждение.
  #Log_TM_Error   ; Ошибка.
EndEnumeration

Enumeration
  #Led_Alarm    ; Светодиод превышения допустимой температуры на аварийных датчиках.
  #Led_Pulse    ; Отображает текущее состояние "пульсирующего" вывода LPT порта.
  #Led_Column   ; Индикатор превышения порога датчика "Колонна".
  #Led_Valve1   ; Индикатор включения клапана 1 (Г. Фракция).
  #Led_Valve2   ; Индикатор включения клапана 2 (Спирт).
  #Led_Valve3   ; Индикатор включения клапана 3 (Т. Фракция).
  #Led_Cube     ; Индикатор превышения порога датчика "Куб".
  #Led_BragaMax ; Индикатор верхнего порога датчика браги.
  #Led_BragaMin ; Индикатор нижнего порога датчика браги.
EndEnumeration

Enumeration 2 ; Цвета светодиодов в окне.
  #LedColor_Off
  #LedColor_Red
  #LedColor_Green
EndEnumeration

Enumeration ; Состояние колонок.
  #StatusStop
  #StatusStart
  #StatusPause
  #StatusSkip
EndEnumeration

Enumeration ; Режимы работы колонки 1 (Ректификация).
  #Col1_Mode_DelayTermo ; После запуска колонки ожидаем перехода порога датчика 3.
  #Col1_Mode_Stabl      ; Стабилизация.
  #Col1_Mode_Valve1     ; Работа клапана 1.
  #Col1_Mode_Valve2     ; Работа клапана 2.
  #Col1_Mode_Valve3     ; Работа клапана 3.
EndEnumeration

#Status_Err = %10000000 ; Состояние ошибки.

Enumeration ; Колонки.
  #Col_1
  #Col_2
  #Col_3
EndEnumeration

Structure AsciiArray
  a.a[0]
EndStructure


;- Logic

Structure Logic_Col1
  Status.a ; Статус работы колонки. См. константы #StatusXXXX.
  Mode.a   ; Режим работы колонки.
  ControlValves.a ; При выкл. колонке определяет состояние капанов. 0-закр. Больше 0, откыт соответсвующий клапан.
  PWM.b           ; Уровень ШИМ на текущем клапане (зависит от режима, т. е. поля Mode).
  CounterPWM.a    ; Счетчик для формирования ШИМ.
  DelayState.a    ; Если не 0, то активна задержка изменения режимов. Время задержки задается в настройках.
  CountDelay.l    ; Счетчик, использующийся для задержки изменения режимов и стабилизации.
  Volume.d        ; Объем в миллилитрах, который проходит за секунду через клапан при 100% ШИМ.
  VolumePWM.d     ; Объем в миллилитрах, который должен пройти через клапан за секунду при текущем ШИМ.
  v1_Volume.d     ; Объем в миллилитрах прошедший через клапан 1.
  v2_Volume.d     ; Объем в миллилитрах прошедший через клапан 2.
  v2_CloseState.a ; Если не 0, то клапан 2 должен быть закрыт.
EndStructure

Structure Logic_Col2
  Work.a   ; #True если колонка работает или #False если остановлена.
EndStructure

Structure Logic_Col3
  Work.a   ; #True если колонка работает или #False если остановлена.
  PinMax.a ; Состояние выводов LPT порта.
  PinMin.a
  OldMax.a
  OldMin.a
EndStructure

Structure LogicParam
  Alarm.a ; Если не 0, то сработал один из аварийных датчиков.
  Col1.Logic_Col1
  Col2.Logic_Col2
  Col3.Logic_Col3
  d6_Pin.a ; Состояние вывода LPT порта, управляемого данными датчика 6.
EndStructure

Structure SensorParam ; Параметры датчика DS18B20.
  StructureUnion
    SN.OW_SN
    ID.q
  EndStructureUnion
  Use.a      ; Использование датчика. См. константы #Sensor_Use_xxxx.
  Termo.w    ; Текущая температура.
  TermoLog.w ; Температура при предыдущем сохранении в термо-лог.
  CountErr.u ; Счетчик ошибок чтения данных.
  CountNoUpdate.u ; Счетчик отсутствия обновлений данных датчика.
  Count85Err.u
  UpdateCount.w
  Flag.a     ; Флаги.См константы #SensorsFlag_xxxx.
EndStructure

Structure Sensors
  List Sensor.SensorParam()  ; Список датчиков температуры.
  CurrentSensor.l            ; Текущий датчик при последовательном опросе датчиков
  PortID.i                   ; Идентификатор COM порта..
  Flags.a                    ; Флаги. См константы #SensorsAll_Flag_xxxx.
EndStructure

Structure CrashProg
  Count.a ; Количество аварийных завершений программы.
  Err.s   ; Описание ошибки.
EndStructure

Structure ProgVar ; Переменные программы.
  LogInfo_FileName.s  ; Имя лог-файла с историей работы программы.
  LogTermo_FileName.s ; Имя лог-файла со значениями температур.
  Sensors.Sensors
  Logic.LogicParam
  Crash.CrashProg
  IsWin9x.a
EndStructure

; - Структуры и константы потока опроса датчиков.

#ThS_FlagIn_Find    = 1 ; Необходимо произвести поиск датчиков.
#ThS_FlagIn_ModifyPort = 2
#ThS_FlagIn_Setting = 4 ; Изменились настройки программы.
#ThS_FlagIn_WinSetting=8
#ThS_FlagOut_SetData= 16 ; Данные о температуре обновлены.
#ThS_FlagOut_Find = 32  ; Найдены или не найдены датчики.


Structure ThSParam
  Mutex.i
  Flags.a   ; Флаги. См. константы #ThS_FlagXXXX.
  NumPort.a ; Номер COM порта.
  Serial.a  ; Последовательный опрос датчиков.
  IsWindow.a ; #True если открыто окно настроек датчиков.
  PortID.i
  List Sensor.SensorParam()
EndStructure

Structure ThS_Sensors Extends Sensors
  NumPort.a ; Номер COM порта.
  Serial.a  ; Последовательный опрос датчиков.
  IsWindow.a ; #True если открыто окно настроек датчиков.
EndStructure

;- Настройки программы.

Structure sLogic
  Performance.l ; Производительность установки мл/час.
  TimeStable.l  ; Время стабилизации в минутах после перехода порога 'датчик3', до начала работы  'клапан1'.
  DelayMode.l   ; Задержка изменения режимов колонки 1 (Ректификация) при превышении порога татчиком 3 (д. Колонна).
  TermoNextMode.w ; Температура перехода из режима 'ожидание нагрева' в режим 'стабилизация'.
  Col1_MinTermo.w ; Минимально допустимая температура колонки 1
  MaxVolume.l  ; Объем в миллилитрах, который должен пройти через клапан 1.
  Valve1_PWM.a  ; ШИМ клапана 1.
  Valve2_Stable.l; Время стабилизации клапана 2.
  Valve3_PWM.a   ; ШИМ клапана 3.
  Valve3_Termo.w ; Порог температуры свыше которого останавливается работа 'клапана 3' и колонки1 (Ректификация).
  Hysteresis_Col3.w
  Check_d6.a
  Termo_d6.w
  Hysteresis_d6.w
  CheckCol1_Auto.a ; Полуавтоматический режим работы колонки 1.
  CheckStopColumn.a; Подтверждать остановку колонок.
EndStructure

Structure sTermoLog
  CheckSavesSec.a
  CheckModify.a
  CheckMaxTermo.a
  CheckSensorErr.a  ; Запись в лог вслучае ошибки датчика.
  SavesSec.l   ; Время в секундах периодического сохранения в лог.
  Modify.u     ; Изменение температуры, при которой будет выполнена запись в лог.
  MaxTermo.w   ; Максимально допустимая температура.
EndStructure

Structure sLog
  InfoShow.a
  InfoFile.a
  WarnShow.a
  WarnFile.a
  ErrShow.a
  ErrFile.a
  AutoScroll.a
  Termo.sTermoLog
EndStructure

Structure sGraph
  Color.l[9] ; Цвета графика. См. константы #GraphColor_xxxx.
  NewDay.a   ; Сохранять график в файл при смене календарного дня.
  AutoScroll.a ; Автопрокрутка графика.
EndStructure

Structure sLPT
  Adr.u     ; Адрес регистра данных LPT порта.
  Pins.a[10] ; Назначение выводов порта. См. константы #LPT_Pin_xxxx.
EndStructure

Structure sSensor_Param
  StructureUnion
    SN.OW_SN
    ID_Arr.a[8] ; Идентификатор датчика.
    ID.q
  EndStructureUnion
  Use.a   ; Использование датчика. См. константы #Sensor_Use_xxxx.
EndStructure

Structure sSensor
  NumPort.a ; Номер COM порта.
  Serial.a  ; Последовательный опрос датчиков.
  List sList.sSensor_Param()
  IsWindow.a ; #True если открыто окно настроек датчиков.
EndStructure

Structure sWinMain ; Настройки в основном окне программы.
  UpdateSetting.l  ; Для отложенного сохранения настроек.
  
  d1_Limit.w
  d2_Limit.w
  d3_Limit.w
  d4_Limit.w
  d5_LimitMax.w
  d5_LimitMin.w
EndStructure

Structure Setting
  Logic.sLogic
  Log.sLog
  Graph.sGraph
  LPT.sLPT
  Sensor.sSensor
  WinMain.sWinMain
EndStructure


Global gSetting.Setting, gVar.ProgVar
Define gSensorThread.ThSParam


Macro SetBit(Var, Bit) ; Установка бита.
  Var | (Bit)
EndMacro

Macro ClearBit(Var, Bit) ; Обнуление бита.
  Var & (~(Bit))
EndMacro

Macro TestBit(Var, Bit) ; Проверка бита (#True - установлен; #False - обнулен).
  Bool(Var & (Bit))
EndMacro

Macro NumToBit(Num)
  (1<<(Num))
EndMacro


; IDE Options = PureBasic 5.50 (Windows - x86)
; CursorPosition = 1
; Folding = -
; EnableXP
; EnableUnicode