﻿CompilerIf #PB_Editor_CreateExecutable
  Declare FatalErr()
  OnErrorCall(@FatalErr())
  SetCurrentDirectory(GetPathPart(ProgramFilename()))
CompilerEndIf

Declare SaveSetting() : Declare WinSensor_SetTable()
Declare MainWin_SetTermo() : Declare SetLedColor(Led, NumColor)
Declare.s wordform(num.i, form_one.s, form_two.s, form_three.s)
Declare SetWinTheme(hWnd, Theme1.s) : Declare Sensor_IsTermoSensor(*Sensor)
Declare FindSensor_Use(Use.a) : Declare SetGUI_Status(Column.a, Status.a)
Declare AddGraphData(Date) : Declare LogPost(String.s, Type)

Define Event, Window, Gadget, Menu, UxThemeID, EndProg=#False, gSensorThID=0

EnableExplicit

XIncludeFile "OWire_Module.pbi"
UseModule OWire

XIncludeFile "ConstStruct.pbi"
XIncludeFile "MainForm.pbf"
XIncludeFile "Setting_Form.pbf"
XIncludeFile "sForm_LPT.pbf"
XIncludeFile "sForm_Sensors.pbf"
XIncludeFile "Graph.pbi"
XIncludeFile "Log.pbi"
XIncludeFile "HID_Module.pbi"
XIncludeFile "USB.pbi"
XIncludeFile "PortDriver.pbi"
XIncludeFile "LPT.pbi"
XIncludeFile "Sensor.pbi"
XIncludeFile "logic.pbi"
XIncludeFile "WinFunct.pbi"


Procedure FatalErr() ; Процедура обработки ошибок.
  Shared UxThemeID, EndProg
  Protected ID, jv, Date.s, File.s, i
  Protected Path.s, StrJs.s="", CrashReport.s
  
  EndProg=#True
  
  RemoveWindowTimer(#Window_Main, #Timer_Sensor)
  UnbindEvent(#PB_Event_Timer, @TimerSensor(), #Window_Main, #Timer_Sensor)
  RemoveWindowTimer(#Window_Main, #Timer_PWM)
  UnbindEvent(#PB_Event_Timer, @TimerPWM(), #Window_Main, #Timer_PWM)
  RemoveWindowTimer(#Window_Main, #Timer_Graph)
  UnbindEvent(#PB_Event_Timer, @TimerGraph(), #Window_Main, #Timer_Graph)
  
  UnbindEvent(#PB_Event_Gadget, Grh::@Scroll_CB(), #Window_Main, #Scrollbar_Graph)
  UnbindEvent(#Event_SensorData, @EventSensor(), #Window_Main)
  UnbindEvent(#Event_Log, @AddLog(), #Window_Main)
    
  If UxThemeID
    CloseLibrary(UxThemeID)
    UxThemeID=0
  EndIf
  
  gVar\Sensors\PortID=0
  
  With gVar\Logic
    \Col3\PinMax=0
    \Col3\PinMin=0
    \d6_Pin=0
  EndWith
  
  dPort::dpOut(gSetting\LPT\Adr+2, %00001011)
  dPort::dpOut(gSetting\LPT\Adr, 0)
  dPort::dpClose()
  
  If gVar\Crash\Count>=10 ; Слишком много ошибок подряд.
    LogWrite("Превышено число перезапусков. Программа не была перезапущена!", #Log_TM_Error)
    ProcedureReturn
  EndIf
  
  gVar\Crash\Count + 1
  
  CompilerIf #PB_Compiler_LineNumbering
    gVar\Crash\Err="Билд: "+Str(#PB_Editor_BuildCount)+"; Строка: "+Str(ErrorLine())+
                   "; Файл '"+GetFilePart(ErrorFile())+"'; Ошибка: "+ErrorMessage()
  CompilerElse
    gVar\Crash\Err="Билд: "+Str(#PB_Editor_BuildCount)+"'; Ошибка: "+ErrorMessage()
  CompilerEndIf
  
  LogWrite("В программе обнаружена ошибка и она будет перезапущена. Подробности - "+gVar\Crash\Err, #Log_TM_Error)
  
  
  Path = GetPathPart(ProgramFilename())
  Date = FormatDate("%dd_%mm_%yyyy__%hh_%ii_%ss", Date())
  File = Path+"Crash.json"
  
  ID = CreateJSON(#PB_Any)
  If ID
    jv = JSONValue(ID)
    If jv
      InsertJSONStructure(jv, @gVar, ProgVar)
      StrJs = ComposeJSON(ID)
      SaveJSON(ID, File)
    EndIf
    FreeJSON(ID)
  EndIf
  
  CrashReport = Path+"Crash__"+Date+".txt"
  If FileSize(CrashReport)<>-1
    For i=1 To 10
      CrashReport = Path+"Crash_"+Str(i)+"__"+Date+".txt"
      If FileSize(CrashReport)=-1
        Break
      EndIf
    Next i
  EndIf
  
  ID = CreateFile(#PB_Any, CrashReport)
  If ID
    CompilerIf #PB_Compiler_Unicode
      WriteStringFormat(ID, #PB_UTF8)
      WriteStringN(ID, gVar\Crash\Err, #PB_UTF8)
      WriteString(ID, #CRLF$+#CRLF$, #PB_UTF8)
      WriteString(ID, StrJs, #PB_UTF8)
    CompilerElse
      WriteStringN(ID, gVar\Crash\Err, #PB_Ascii)
      WriteString(ID, #CRLF$+#CRLF$, #PB_Ascii)
      WriteString(ID, StrJs, #PB_Ascii)
    CompilerEndIf
    CloseFile(ID)
  Else
    LogWrite("Не удалось сохранить файл "+GetFilePart(CrashReport), #Log_TM_Error)
  EndIf
  
  If gSetting\WinMain\UpdateSetting<=10
    SaveSetting()
  EndIf
    
  If FileSize(File)>0
    If RunProgram(ProgramFilename(), "/CrashFile "+Chr(34)+File+Chr(34), Path)=0
      LogWrite("Не удалось перезапуcтить программу!", #Log_TM_Error)
    EndIf
  Else
    LogWrite("Не удалось сохранить файл "+GetFilePart(File)+"  Программа не была перезапущена!", #Log_TM_Error)
  EndIf
  
  End
EndProcedure 

Procedure SetWinTheme(hWnd, Theme.s)
  Shared UxThemeID
  
  If UxThemeID
    CallFunction(UxThemeID, "SetWindowTheme", hWnd, @Theme, 0)
  EndIf
  
EndProcedure

Procedure.s wordform(num.i, form_one.s, form_two.s, form_three.s)
  num % 100 
  Protected num_two.i = num % 10 
  If num > 10 And num < 20 
    ProcedureReturn form_three 
  EndIf 
  If num_two > 1 And num_two < 5 
    ProcedureReturn form_two 
  EndIf 
  If num_two = 1
    ProcedureReturn form_one 
  EndIf 
  ProcedureReturn form_three 
EndProcedure

Procedure ReadSetting()
  Protected File, i, Count, TempQ.q, x
  
  File = OpenPreferences("Setting.ini")
  
  PreferenceGroup("Logic")
  With gSetting\Logic
    \Performance = ReadPreferenceLong("Performance", 1000)
    \TimeStable  = ReadPreferenceLong("TimeStable", 2)
    \DelayMode   = ReadPreferenceLong("DelayMode", 10)
    \TermoNextMode = ReadPreferenceLong("TermoNextMode", 740)
    \Col1_MinTermo = ReadPreferenceLong("Col1_MinTermo", 500)
    \MaxVolume = ReadPreferenceLong("MaxVolume", 1000)
    \Valve1_PWM  = ReadPreferenceLong("Valve1_PWM", 100)
    \Valve2_Stable = ReadPreferenceLong("Valve2_Stable", 4)
    \Valve3_PWM  = ReadPreferenceLong("Valve3_PWM", 50)
    \Valve3_Termo= ReadPreferenceLong("Valve3_Termo", 900)
    \Hysteresis_Col3=ReadPreferenceLong("Hysteresis_Col3", 5)
    \Check_d6    = Bool(ReadPreferenceLong("Check_d6", 1))
    \Termo_d6    = ReadPreferenceLong("Termo_d6", 500)
    \Hysteresis_d6 = ReadPreferenceLong("Hysteresis_d6", 20)
    \CheckCol1_Auto = Bool(ReadPreferenceLong("Col1_Auto", 0))
    \CheckStopColumn= Bool(ReadPreferenceLong("CheckStopColumn", 0))
  EndWith
  
  PreferenceGroup("Log")
  With gSetting\Log
    \InfoShow = Bool(ReadPreferenceLong("InfoShow", 1))
    \InfoFile = Bool(ReadPreferenceLong("InfoFile", 1))
    \WarnShow = Bool(ReadPreferenceLong("WarnShow", 1))
    \WarnFile = Bool(ReadPreferenceLong("WarnFile", 1))
    \ErrShow = Bool(ReadPreferenceLong("ErrShow", 1))
    \ErrFile = Bool(ReadPreferenceLong("ErrFile", 1))
    \AutoScroll = Bool(ReadPreferenceLong("AutoScroll", 1))
  EndWith
  
  With gSetting\Log\Termo
    \CheckSavesSec = Bool(ReadPreferenceLong("CheckSavesSec", 1))
    \CheckModify = Bool(ReadPreferenceLong("CheckModify", 1))
    \CheckMaxTermo = Bool(ReadPreferenceLong("CheckMaxTermo", 1))
    \CheckSensorErr = Bool(ReadPreferenceLong("CheckSensorErr", 1))
    \SavesSec = ReadPreferenceLong("SavesSec", 10)
    \Modify = ReadPreferenceLong("Modify", 50)
    \MaxTermo = ReadPreferenceLong("MaxTermo", 1000)
  EndWith
  
  PreferenceGroup("Graph")
  With gSetting\Graph
    \Color[0] = ReadPreferenceLong("Color0", 16777215)
    \Color[1] = ReadPreferenceLong("Color1", 12632256)
    \Color[2] = ReadPreferenceLong("Color2", 32768)
    \Color[3] = ReadPreferenceLong("Color3", 6881490)
    \Color[4] = ReadPreferenceLong("Color4", 255)
    \Color[5] = ReadPreferenceLong("Color5", 4227072)
    \Color[6] = ReadPreferenceLong("Color6", 16744448)
    \Color[7] = ReadPreferenceLong("Color7", 12615680)
    \Color[8] = ReadPreferenceLong("Color8", $FF12E012)
    
    \NewDay = Bool(ReadPreferenceLong("NewDay", 1))
    \AutoScroll=Bool(ReadPreferenceLong("AutoScroll", 1))
  EndWith
  
  x = #False
  PreferenceGroup("LPT")
  With gSetting\LPT
    \Adr = ReadPreferenceLong("Adr", 888)
    For i=0 To 9
      \Pins[i] = ReadPreferenceLong("Pin"+i, i)
      If \Pins[i]<0 And \Pins[i]>=12
        x = #True
      EndIf
    Next i
    If TestAsciiArray_Duplicate(@\Pins[0], SizeOf(sLPT\Pins))=#False
      LogWrite("Одному или более выводу LPT порта назначено несколько функций!", #Log_TM_Error)
    EndIf
    If x = #True
      LogWrite("Одному или более выводу LPT порта назначен неправильный номер!", #Log_TM_Error)
    EndIf
  EndWith
  
  PreferenceGroup("Sensor")
  With gSetting\Sensor
    \NumPort = ReadPreferenceLong("NumPort", 0)
    \Serial = Bool(ReadPreferenceLong("Serial", 0))
    Count = ReadPreferenceLong("SensorsCount", 0)
    For i=1 To Count
      TempQ = ReadPreferenceQuad("ID_"+Str(i), 0)
      If TempQ
        If AddElement(\sList())
          \sList()\Use = ReadPreferenceLong("Use_"+Str(i), #Sensor_Use_None)
          \sList()\ID = TempQ
        EndIf
      EndIf
    Next i
  EndWith
  
  PreferenceGroup("WinMain")
  With gSetting\WinMain
    \d1_Limit = ReadPreferenceLong("d1_Limit", 900)
    \d2_Limit = ReadPreferenceLong("d2_Limit", 900)
    \d3_Limit = ReadPreferenceLong("d3_Limit", 800)
    \d4_Limit = ReadPreferenceLong("d4_Limit", 752)
    \d5_LimitMax = ReadPreferenceLong("d5_LimitMax", 900)
    \d5_LimitMin = ReadPreferenceLong("d5_LimitMin", 800)
  EndWith
    
  If File
    ClosePreferences()
  EndIf
  
EndProcedure

Procedure SaveSetting()
  Protected i, Count, TempQ.q
  
  If CreatePreferences("Setting.ini")
    
    PreferenceGroup("Logic")
    With gSetting\Logic
      WritePreferenceLong("Performance", \Performance)
      WritePreferenceLong("TimeStable", \TimeStable)
      WritePreferenceLong("DelayMode", \DelayMode)
      WritePreferenceLong("TermoNextMode", \TermoNextMode)
      WritePreferenceLong("Col1_MinTermo", \Col1_MinTermo)
      WritePreferenceLong("MaxVolume", \MaxVolume)
      WritePreferenceLong("Valve1_PWM", \Valve1_PWM)
      WritePreferenceLong("Valve2_Stable", \Valve2_Stable)
      WritePreferenceLong("Valve3_PWM", \Valve3_PWM)
      WritePreferenceLong("Valve3_Termo", \Valve3_Termo)
      WritePreferenceLong("Hysteresis_Col3", \Hysteresis_Col3)
      WritePreferenceLong("Check_d6", \Check_d6)
      WritePreferenceLong("Termo_d6", \Termo_d6)
      WritePreferenceLong("Hysteresis_d6", \Hysteresis_d6)
      WritePreferenceLong("Col1_Auto", \CheckCol1_Auto)
      WritePreferenceLong("CheckStopColumn", \CheckStopColumn)
    EndWith
    
    PreferenceGroup("Log")
    With gSetting\Log
      WritePreferenceLong("InfoShow", \InfoShow)
      WritePreferenceLong("InfoFile", \InfoFile)
      WritePreferenceLong("WarnShow", \WarnShow)
      WritePreferenceLong("WarnFile", \WarnFile)
      WritePreferenceLong("ErrShow", \ErrShow)
      WritePreferenceLong("ErrFile", \ErrFile)
      WritePreferenceLong("AutoScroll", \AutoScroll)
    EndWith
    
    With gSetting\Log\Termo
      WritePreferenceLong("CheckSavesSec", \CheckSavesSec)
      WritePreferenceLong("CheckModify", \CheckModify)
      WritePreferenceLong("CheckMaxTermo", \CheckMaxTermo)
      WritePreferenceLong("CheckSensorErr", \CheckSensorErr)
      WritePreferenceLong("SavesSec", \SavesSec)
      WritePreferenceLong("Modify", \Modify)
      WritePreferenceLong("MaxTermo", \MaxTermo)
    EndWith
    
    PreferenceGroup("Graph")
    With gSetting\Graph
      For i=0 To 8
        WritePreferenceLong("Color"+Str(i), \Color[i])
      Next i
      WritePreferenceLong("NewDay", \NewDay)
      WritePreferenceLong("AutoScroll", \AutoScroll)
    EndWith
    
    PreferenceGroup("LPT")
    With gSetting\LPT
      WritePreferenceLong("Adr", \Adr)
      For i=0 To 9
        WritePreferenceLong("Pin"+i, \Pins[i])
      Next i
    EndWith
    
    PreferenceGroup("Sensor")
    With gSetting\Sensor
      WritePreferenceLong("NumPort", \NumPort)
      WritePreferenceLong("Serial", \Serial)
      WritePreferenceLong("SensorsCount", ListSize(\sList()))
      i=0
      ForEach \sList()
        i+1
        TempQ = \sList()\ID
        If TempQ
          WritePreferenceQuad("ID_"+Str(i), TempQ)
          WritePreferenceLong("Use_"+Str(i), \sList()\Use)
        EndIf
      Next
    EndWith
    
    PreferenceGroup("WinMain")
    With gSetting\WinMain
      WritePreferenceLong("d1_Limit", \d1_Limit)
      WritePreferenceLong("d2_Limit", \d2_Limit)
      WritePreferenceLong("d3_Limit", \d3_Limit)
      WritePreferenceLong("d4_Limit", \d4_Limit)
      WritePreferenceLong("d5_LimitMax", \d5_LimitMax)
      WritePreferenceLong("d5_LimitMin", \d5_LimitMin)
    EndWith
    
    ClosePreferences()
  Else
    LogWrite("Не удалось сохранить настройки в файле", #Log_TM_Warning)
  EndIf
EndProcedure

Procedure IsRestart() ; Проверка перезапуска программы и если обнаружен - восстановление данных памяти из файла.
  Protected Result = #False
  Protected File.s, ID, jv
  
  If CountProgramParameters()>=2
    If ProgramParameter(0)="/CrashFile"
      File = ProgramParameter(1)
      If FileSize(File)>0
        ID = LoadJSON(#PB_Any, File)
        If ID
          jv = JSONValue(ID)
          If jv
            ExtractJSONStructure(jv, @gVar, ProgVar)
            Result = #True
          EndIf
          FreeJSON(ID)
        EndIf
        DeleteFile(File, #PB_FileSystem_Force)
      EndIf
    EndIf
  EndIf
  
  ProcedureReturn Result
EndProcedure

Procedure InitProg() ; Инициализация программы.
  Shared UxThemeID, gSensorThread, gSensorThID
  Protected ProgPath.s, Date, Restart, i
  Protected Graph.grh::GraphInit, OS_Version
    
  OS_Version = OSVersion()
    
  If OS_Version=#PB_OS_Windows_95 Or OS_Version=#PB_OS_Windows_98 Or OS_Version=#PB_OS_Windows_ME
    gVar\IsWin9x=#True
  ElseIf OS_Version=#PB_OS_Windows_NT_4
    MessageRequester(#ProgName, "Операционная система Windows NT не поддерживается этой программой",
                     #MB_ICONWARNING)
    End
  Else
    gVar\IsWin9x=#False
  EndIf
  
    
  ProgPath = GetPathPart(ProgramFilename())
  
  UxThemeID = OpenLibrary(#PB_Any, "UxTheme.dll")
  
  OpenWindow_Main()
  SetWindowLongPtr_(GadgetID(#ListView_Log), #GWL_STYLE, 
                    GetWindowLongPtr_(GadgetID(#ListView_Log), #GWL_STYLE)|#LVS_NOCOLUMNHEADER)
  
  If gVar\IsWin9x=#False
    SendMessage_(GadgetID(#ListView_Log), #LVM_SETEXTENDEDLISTVIEWSTYLE,
                 #LVS_EX_LABELTIP, #LVS_EX_LABELTIP)
  EndIf
  
  If OS_Version>=#PB_OS_Windows_7
    SetWinTheme(GadgetID(#ListView_Log), "Explorer")
  EndIf
  
  
  If CreatePopupMenu(#MenuPopup_Grph)
    MenuItem(#mItem_Graph_Setting, "Настройки")
    MenuBar()
    MenuItem(#mItem_Graph_AutoScroll, "Автопрокрутка")
  EndIf
  
  If CreatePopupMenu(#MenuPopup_Log)
    MenuItem(#mItem_Log_Setting, "Настройки")
    MenuBar()
    MenuItem(#mItem_Log_AutoScroll, "Автопрокрутка")
  EndIf
  
  If CreatePopupMenu(#MenuPopup_Sensor)
    MenuItem(#mItem_Sensor_None, "Не используется")
    MenuBar()
    MenuItem(#mItem_Sensor_d1, "ав. ТСА")
    MenuItem(#mItem_Sensor_d2, "ав. Конденсатор")
    MenuItem(#mItem_Sensor_d3, "д. Колонна")
    MenuItem(#mItem_Sensor_d4, "д. Куб")
    MenuItem(#mItem_Sensor_d5, "д. Брага")
    MenuItem(#mItem_Sensor_d6, "Датчик 6")
  EndIf
  
  
  SetLedColor(#Led_Alarm, #LedColor_Off)
  SetLedColor(#Led_Pulse, #LedColor_Off)
  
  ColumnSetStatus(#Col_1, #StatusStop)
  ColumnSetStatus(#Col_2, #StatusStop)
  ColumnSetStatus(#Col_3, #StatusStop)
  
  ReadSetting()
  
  Restart = IsRestart()
  
  If Restart = #False
    Date = Date()
    gVar\LogInfo_FileName = ProgPath+"Log\"+FormatDate("%dd_%mm_%yyyy__%hh_%ii_%ss", Date)+".log"
    gVar\LogTermo_FileName = ProgPath+"Log\Termo_"+FormatDate("%dd_%mm_%yyyy__%hh_%ii_%ss", Date)+".log"
    
    With gSetting\Sensor
      ForEach \sList()
        If \sList()\ID
          If AddElement(gVar\Sensors\Sensor())
            gVar\Sensors\Sensor()\ID = \sList()\ID
            gVar\Sensors\Sensor()\Use = \sList()\Use
            gVar\Sensors\Sensor()\Flag = 0
            If Sensor_IsTermoSensor(@gVar\Sensors\Sensor()\SN)
              SetBit(gVar\Sensors\Sensor()\Flag, #SensorsFlag_TermoSensor)
            EndIf
          EndIf
        EndIf
      Next
    EndWith
    
  Else

    Delay(400)
    LogWrite("Программа была перезапущена. Подробности ошибки; "+gVar\Crash\Err, #Log_TM_Warning)
    
    If gVar\Logic\Alarm=#True
      LogWrite("Работа колонок 'Ректификация' и 'Дистилляция' заблокирована до перезапуска программы!",
               #Log_TM_Warning)
      ColumnSetStatus(#Col_1, #StatusStop|#Status_Err)
      ColumnSetStatus(#Col_2, #StatusStop|#Status_Err)
      SetLedColor(#Led_Alarm, #LedColor_Red)
    Else
      
      
      With gVar\Logic\Col1
        SetGUI_Status(#Col_1, \Status)
        If \Status = #StatusStop Or \Status=#StatusPause ; Ручное управление клапанами.
          If \ControlValves>0
            Select \ControlValves
              Case 1 ; Первый клапан.
                SetGadgetState(#Button_Valve1, 1)
                PostEvent(#PB_Event_Gadget, #Window_Main, #Button_Valve1)
              Case 2 ; Второй клапан.
                SetGadgetState(#Button_Valve2, 1)
                PostEvent(#PB_Event_Gadget, #Window_Main, #Button_Valve2)
              Case 3 ; Третий клапан.
                SetGadgetState(#Button_Valve2, 1)
                PostEvent(#PB_Event_Gadget, #Window_Main, #Button_Valve2)
            EndSelect
          EndIf
        EndIf
      EndWith
      
      If gVar\Logic\Col2\Work
        SetLedColor(#Led_Cube, #LedColor_Green)
        SetGUI_Status(#Col_2, #StatusStart)
      EndIf
    EndIf
    
    If gVar\Logic\Col3\Work
      SetGUI_Status(#Col_3, #StatusStart)
    EndIf
  EndIf
  
  OW_SetMode(#OW_Mode_CPU_MinUsage)
  
  BindEvent(#Event_Log, @AddLog(), #Window_Main)
  
  
  gSensorThread\Mutex=CreateMutex()
  If gSensorThread\Mutex
    
    gSensorThread\NumPort = gSetting\Sensor\NumPort
    gSensorThread\Serial=gSetting\Sensor\Serial
    gSensorThread\Flags=0
    CopyList(gVar\Sensors\Sensor(), gSensorThread\Sensor())
    
    gSensorThID=CreateThread(@Sensor_Thread(), @gSensorThread)
    If gSensorThID=0
      LogWrite("Не удалось создать поток чтения данных из датчиков.", #Log_TM_Error)
      MessageRequester(#ProgName, "Не удалось создать поток чтения данных из датчиков.", #MB_ICONERROR)
      FreeMutex(gSensorThread\Mutex)
      gSensorThread\Mutex=0
      End
    EndIf
  Else
    LogWrite("Не удалось создать мьютекс.", #Log_TM_Error)
    MessageRequester(#ProgName, "Не удалось создать мьютекс.", #MB_ICONERROR)
    End
  EndIf
  
  gSetting\WinMain\UpdateSetting = 100
  
  If dPort::dpInit()
    dPort::dpOut(gSetting\LPT\Adr, 0)
  Else
    LogWrite("Не удалось загрузить драйвер LPT порта. Возможно он не установлен.", #Log_TM_Error)
  EndIf
  
  HID::HID_Init()
  
  If Restart ; Формирование импульса, сообщающего об ошибке.
    If gVar\Logic\Alarm=0
      
      gVar\Logic\Alarm=1
      LPT_Core()
      Delay(400)
      gVar\Logic\Alarm=0
      LPT_Core()
      
    EndIf
  EndIf
  
  Graph\Font = #Font_Graph
  Graph\FontName = "Arial"
  Graph\FontSize = 8
  Graph\GraphGadget = #Canvas_Graph
  Graph\ScrollGadget = #Scrollbar_Graph
  Graph\LogFunct = @GraphLog()
  If grh::GraphInit(@Graph)
    BindEvent(#PB_Event_Gadget, Grh::@Scroll_CB(), #Window_Main, #Scrollbar_Graph)
  Else
    LogWrite("Неудачная инициализация графика.", #Log_TM_Error)
  EndIf
  
  CopyCraphSetting()
  SetParam_WinMain()

  grh::GraphDraw()
  TimerSensor()
  HideWindow(#Window_Main, #False)
  
  AddWindowTimer(#Window_Main, #Timer_Sensor, 998)
  BindEvent(#PB_Event_Timer, @TimerSensor(), #Window_Main, #Timer_Sensor)
  AddWindowTimer(#Window_Main, #Timer_PWM, 94)
  BindEvent(#PB_Event_Timer, @TimerPWM(), #Window_Main, #Timer_PWM)
  AddWindowTimer(#Window_Main, #Timer_Graph, 100)
  BindEvent(#PB_Event_Timer, @TimerGraph(), #Window_Main, #Timer_Graph)
  BindEvent(#Event_SensorData, @EventSensor(), #Window_Main)
EndProcedure

Procedure EndProg() ; Завершение работы программы.
  Shared UxThemeID, EndProg, gSensorThID, gSensorThread
  
  EndProg=#True
  
  HideWindow(#Window_Main, #True)
  
  If IsWindow(#Window_Setting)
    HideWindow(#Window_Setting, #True)
  EndIf
  
  If IsWindow(#Window_sLPT)
    HideWindow(#Window_sLPT, #True)
  EndIf
  
  If IsWindow(#Window_Sensors)
    HideWindow(#Window_Sensors, #True)
  EndIf
  
  RemoveWindowTimer(#Window_Main, #Timer_Sensor)
  UnbindEvent(#PB_Event_Timer, @TimerSensor(), #Window_Main, #Timer_Sensor)
  RemoveWindowTimer(#Window_Main, #Timer_PWM)
  UnbindEvent(#PB_Event_Timer, @TimerPWM(), #Window_Main, #Timer_PWM)
  RemoveWindowTimer(#Window_Main, #Timer_Graph)
  UnbindEvent(#PB_Event_Timer, @TimerGraph(), #Window_Main, #Timer_Graph)
  
  UnbindEvent(#PB_Event_Gadget, Grh::@Scroll_CB(), #Window_Main, #Scrollbar_Graph)
  UnbindEvent(#Event_SensorData, @EventSensor(), #Window_Main)
  UnbindEvent(#Event_Log, @AddLog(), #Window_Main)
  
  If UxThemeID
    CloseLibrary(UxThemeID)
    UxThemeID=0
  EndIf
  
  If gSetting\WinMain\UpdateSetting<=10
    SaveSetting()
  EndIf
  
  dPort::dpOut(gSetting\LPT\Adr+2, %00001011)
  dPort::dpOut(gSetting\LPT\Adr, 0)
  dPort::dpClose()
  
  USB_End()
  HID::HID_End()
  
  If gVar\IsWin9x=#False
    WaitThread(gSensorThID, 1000)
  Else
    WaitThread(gSensorThID, 8000)
  EndIf
  
  If IsThread(gSensorThID)
    KillThread(gSensorThID)
    gSensorThID=0
  EndIf
  
  If gSensorThread\Mutex
    FreeMutex(gSensorThread\Mutex)
    gSensorThread\Mutex=0
  EndIf
  
EndProcedure

InitProg()

Repeat
  Event = WaitWindowEvent()
  Window = EventWindow()
  
  If Window = #Window_Main
    If Event = #PB_Event_CloseWindow
      Break
    EndIf
    WinMain_Event(Event)
  ElseIf Window = #Window_sLPT
    Win_sLPT_Event(Event)
  ElseIf Window = #Window_Sensors
    WinSensors_Event(Event)
  ElseIf Window = #Window_Setting
    WinSetting_Event(Event)
  EndIf
  
ForEver

EndProg()
End


; IDE Options = PureBasic 5.43 LTS (Windows - x86)
; Folding = --
; EnableUnicode
; EnableXP
; CompileSourceDirectory